{
  Faca um procedimento Remove que procure em uma lista encadeada e delete
  todos os elementos contendo o valor de uma variavel inteira X, onde X eh
  um numero inteiro introduzido pelo usuario.
}

program RemoveNosIguaisAUmaVariavel;
(* Remove o(s) no(s) de uma lista encadeada cujo conteudo eh igual ao numero *)
(* inteiro introduzido                                                       *)

const
   NUMERO_DE_NOS = 6;
type
   tApontador = ^no;
   no = record
              valorInteiro:integer;
              proximo:tApontador
        end;
var
   cabeca,ptrDesaloca,ponteiroAux : tApontador;
   i,numInteiro : integer;

procedure CriaLista(var lista : tApontador);
(* Cria uma lista encadeada *)

var
   i : integer;
   ptrAuxiliar, noNovo : tApontador;

begin
   writeln('Introduza ',NUMERO_DE_NOS,' numeros inteiros (um em cada linha) :');
   new(lista);
   (* Leitura do conteudo do primeiro no da lista *)
   readln(lista^.valorInteiro);
   ptrAuxiliar:=lista; (* ptrAuxiliar passa a apontar para a mesma posicao *)
                       (* de memoria apontada por lista, desse modo a      *)
                       (* cabeca da lista nao se "perde"                   *)

   for i := 2 to NUMERO_DE_NOS do begin
       new(noNovo); (* Criacao de um novo no *)
       readln(noNovo^.valorInteiro); (* Preenchemento do no *)
       ptrAuxiliar^.proximo := noNovo; (* Encadea o novo no com o anterior *)

       ptrAuxiliar := noNovo (* ptrAuxiliar, que estava apontando para o    *)
                             (* primeiro no, passa a apontar para o novo no *)
   end;
   ptrAuxiliar^.proximo := nil (* Atribui o valor "nil" ao campo "proximo" *)
                               (* do ultimo no da lista criada             *)
end; (* CriaLista *)

procedure RemoveNo(var lista:tApontador;valorNaLista:integer);
(* Remove um no cujo valor eh valorNaLista na lista apontada por *)
(* "lista"(cabeca da lista)                                      *)

var
   noAnterior, posicaoDoNo:tApontador;
   noFoiEncontrado:boolean;

begin
   posicaoDoNo := lista; (* Comeca a busca a partir da cabeca da lista *)
   noAnterior := nil; (* No inicio da lista nao existe no anterior *)
   noFoiEncontrado := false; (* Indica que no ainda nao foi encontrado *)

   while (posicaoDoNo <> nil) and (not noFoiEncontrado) do (* Procura no *)
       if(posicaoDoNo^.valorInteiro = valorNaLista)then
           noFoiEncontrado := true (* No procurado foi encontrado *)
       else begin
            noAnterior := posicaoDoNo; (* No anterior passa a ser o atual *)
            posicaoDoNo := posicaoDoNo^.proximo; (* Atual passa a ser o proximo *)
       end; (* if *)

   if noFoiEncontrado then
       if (noAnterior = nil) then (* No a ser removido eh o primeiro da lista *)
           lista := lista^.proximo (* O primeiro no agora sera o antigo segundo no *)
       else  (* No a ser removido nao eh o primeiro *)
           noAnterior^.proximo := posicaoDoNo^.proximo; (* Faz o desvio *)

   dispose(posicaoDoNo) (* Libera a alocacao de memoria do no removido *)
end; (* RemoveNo *)

begin
   (* Leitura do numero inteiro *)
   writeln('Introduza um numero inteiro :');
   readln(numInteiro);

   CriaLista(cabeca);

   ponteiroAux := cabeca; (* ptrAuxiliar passa a apontar para a mesma posicao *)
                          (* de memoria apontada por lista, desse modo a      *)
                          (* cabeca da lista nao se "perde"                   *)

   while (ponteiroAux <> nil) do begin
       (* Verifica se o conteudo do no eh igual ao numero inteiro *)
       if (ponteiroAux^.valorInteiro = numInteiro) then begin
           ponteiroAux := ponteiroAux^.proximo; (* "ponteiroAux" passa a     *)
                                                (* apontar para o proximo no *)

           RemoveNo(cabeca,numInteiro); (* O no cujo conteudo eh igual ao *)
                                        (* numero inteiro eh removido     *)
       end
       else
           ponteiroAux := ponteiroAux^.proximo;
   end;

   (* Impressao e desalocacao da lista encadeada apos a remorsao *)
   writeln('A lista inicial apos a retirada do(s) ',numInteiro,' eh :');
   while (cabeca <> nil) do begin
       writeln(cabeca^.valorInteiro);
       ptrDesaloca := cabeca; (* Atribuicao do ponteiro, cujo campo "nome" *)
                              (* foi impresso, ao ponteiro ptrDesaloca     *)
       cabeca := cabeca^.proximo;
       dispose(ptrDesaloca); (* Liberacao do espaco ocupado por ptrDesaloca *)
   end;
end.

