{
  Crie um registro que contenha uma sequencia de nomes e datas de nascimento.
  Escreva um programa que imprima essa lista de nomes e datas em ordem cronologica
  no seguinte formato : Nome-dd/mm/aa (onde dd eh o dia, mm eh o mes e aa eh o ano).
}

program OrdemCronologica;
(* Recebe como entrada uma lista de nomes de pessoas com suas respectivas datas *)
(* de nascimento e retorna como saida essa lista em ordem cronologica           *)

const
   N = 10;
type
   tNome = string[50];
   tData = record
                 dia, mes, ano : integer;
           end;
   tDataDeNascimento = record
    						 nome : tNome;
                             data : tData;
                       end;
   tNascimento = array [1..N] of tDataDeNascimento;

var
   i : integer;
   aniversariante : tNascimento;

procedure OrdenaCronologicamente(var aniv : tNascimento);
(* Ordena uma lista de nomes de pessoas com suas respectivas datas de nascimento *)
(* cronologicamente (i.e., da maior para a menor idade)                          *)

var
   i: integer;
   aux : tDataDeNascimento;
   ordenado : boolean;

begin
   (* Ordena, do menor para o maior, os anos das datas *)
   ordenado := false;
   while (not ordenado) do begin
       ordenado := true;
       for i := 1 to (N-1) do
           if (aniv[i].data.ano > aniv[i+1].data.ano) then begin
               ordenado := false;
               aux := aniv[i];
               aniv[i] := aniv[i+1];
               aniv[i+1] := aux;
           end;
   end;

   (* Ordena os meses, do maior para o menor, das datas de mesmo ano *)
   ordenado := false;
   while (not ordenado) do begin
       ordenado := true;
       for i := 1 to (N-1) do
           if ((aniv[i].data.ano = aniv[i+1].data.ano) and (aniv[i].data.mes > aniv[i+1].data.mes)) then begin
               ordenado := false;
               aux := aniv[i];
               aniv[i] := aniv[i+1];
               aniv[i+1] := aux;
           end;
   end;

   (* Ordena os dias, do maior para o menor, das datas de mesmo ano e mes *)
   ordenado := false;
   while (not ordenado) do begin
       ordenado := true;
       for i := 1 to (N-1) do
           if (aniv[i].data.ano = aniv[i+1].data.ano) then
               if ((aniv[i].data.mes = aniv[i+1].data.mes) and (aniv[i].data.dia > aniv[i+1].data.dia)) then begin
                   ordenado := false;
                   aux := aniv[i];
                   aniv[i] := aniv[i+1];
                   aniv[i+1] := aux;
               end; (* if *)
   end; (* while *)
end; (* OrdenaCronologicamente *)

begin
   (* Leitura do nome e da data de nascimento *)
   for i := 1 to N do begin
       writeln('Digite o nome e a data de nascimento (separada por enter) do individuo :');
       with aniversariante[i] do
           readln(nome, data.dia, data.mes, data.ano);
   end;

   (* Ordenacao cronologica das datas de nascimentos *)
   OrdenaCronologicamente(aniversariante);

   (* Impressao da lista *)
   writeln('Datas de nascimento :');
   for i := 1 to N do
       with aniversariante[i] do
           writeln(nome,'-',data.dia,'/',data.mes,'/',data.ano);
end.
