{
  Escreva um programa que leia o nome e as notas de cada aluno de uma certa
  turma e imprima uma lista, ordenada de forma decrescente de acordo com as
  medias finais dos alunos, contendo o nome e a media final de cada aluno.
}

program OrdenaNotas;
(* Recebe como entrada o nome e as notas de cada aluno de uma certa turma e   *)
(* retorna como saida uma lista, ordenada de forma decrescente de acordo com  *)
(* as medias finais dos alunos, contendo o nome e a media final de cada aluno *)

const
   N = 10;
type
   tAluno = record
    			  nome : string[50];
                  nota1, nota2, nota3, nota4, notaFinal, media, mediaFinal : real
    		end;
   tArranjo = array [1..N] of tAluno;
var
   i : integer;
   alunos : tArranjo;

procedure LeDadosDoAluno(var aluno : tArranjo);
(* Le nome e notas de cada aluno *)

var
   i : integer;

begin
   for i := 1 to N do begin
       with aluno[i] do begin
	       writeln('Digite o nome e as quatro notas do aluno (um dado por linha) :');
           readln(nome);
           readln(nota1,nota2,nota3,nota4);
           media := ( nota1 + nota2 + nota3 + nota4 ) / 4;  (* Calculo da media *)

   (* Solicita a nota final apenas do aluno que nao foi aprovado por media *)
           if (media < 7.0) then begin
               writeln('Introduza a nota da prova final :');
               readln(notaFinal);
           end; (* if *)
       end; (* with *)
   end; (* for *)
end; (* procedimento *)

procedure CalculaMediaFinal(var aluno : tArranjo);
(* Calcula a media final de cada aluno *)

var
    i : integer;

begin
   for i := 1 to N do
       with aluno[i] do
           if (media >= 7.0) then
               mediaFinal := media
           else
               mediaFinal := ( 6*media + 4*notaFinal ) / 10
end;

procedure OrdenaArranjo(var aluno : tArranjo);
(* Ordena, de forma decrescente, o arranjo de notas de acordo com a media *)
(* final de cada aluno                                                    *)

var
   i : integer;
   aux : tAluno;
   ordenado : boolean;

begin
   ordenado := false;
   while (not ordenado) do begin
       ordenado := true;
       for i := 1 to (N-1) do
           if (aluno[i].mediaFinal < aluno[i+1].mediaFinal) then begin
               ordenado := false;
               aux := aluno[i];
               aluno[i] := aluno[i+1];
               aluno[i+1] := aux;
           end; (* if *)
   end; (* while *)
end; (* OrdenaArranjo *)

begin
   LeDadosDoAluno(alunos);    (* Leitura do nome e das notas dos alunos *)
   CalculaMediaFinal(alunos);    (* Calculo da media final dos alunos *)
   OrdenaArranjo(alunos);    (* Ordenacao da lista de alunos *)

   (* Impressao da lista *)
   writeln('A lista de alunos na ordem crescente, de acordo com a media final, eh :');
   for i := 1 to N do
       with alunos[i] do
           writeln('Aluno(a) : ',nome,'.  Media Final : ',mediaFinal:4:2);
end.