{
  Em um disco estao gravados dois arquivos: um com os numeros de matricula e
  os salarios dos funcionarios de uma empresa, e o outro com as matriculas e
  os nomes de cada funcionario. Imprima uma listagem em ordem alfabetica dos
  nomes dos funcionarios acompanhados dos respectivos salarios.
}

program RegistroDeEmpregados;
(* Dados dois arquivos, um contendo os numeros de matricula e os salarios, e o      *)
(* outro contendo as matriculas e os nomes de cada funcionario, o programa imprime  *)
(* uma listagem em ordem alfabetica dos nomes dos funcionarios acompanhados dos     *)
(* respectivos salarios                                                             *)

const
   EMPREGADOS = 6;
type
   tMatricula = string[9];
   tNome = string[30];
   tRegistro1 = record
                     matricula : tMatricula;
                     nome : tNome;
                end;
   tRegistro2 = record
                      matricula : tMatricula;
                      salario : real;
                end;
   tRegistroAuxiliar = record
                             nome : tNome;
                             salario : real;
                       end;
   tArranjo1 = array[1..EMPREGADOS] of tRegistro1;
   tArranjo2 = array[1..EMPREGADOS] of tRegistro2;
   tArranjoAuxiliar = array[1..EMPREGADOS] of tRegistroAuxiliar;

var
   arquivoDeEmpregados1, arquivoDeEmpregados2 : text;
   nomeEMatricula : tArranjo1;
   salarioEMatricula : tArranjo2;
   nomeESalario : tArranjoAuxiliar;
   i, j, k : integer;

procedure OrdenaNomes(var arDeNomesEMats : tArranjo1);
(* Ordena os elementos de um arranjo *)

var
   i, j : integer;
   ordenou : boolean;
   auxiliaNome : tNome;
   auxiliaMatricula : tMatricula;

begin
   ordenou := false;
   while (not ordenou) do begin
       ordenou := true; (* Considera que a lista ja esta ordenada *)
           for i := 1 to (EMPREGADOS - 1) do begin
               j := 1;
               (* Incrementa-se o j ate que os caracteres que estao sendo *)
               (* comparados sejam diferentes                             *)
               while (arDeNomesEMats[i].nome[j] = arDeNomesEMats[i + 1].nome[j]) do
                   j := j + 1;

               (* Ao chegar nos caracteres diferentes, verifica-se se o do *)
               (* primeiro nome eh maior que o do segundo                  *)
               if (ord(arDeNomesEMats[i].nome[j]) > ord(arDeNomesEMats[i + 1].nome[j])) then begin
                   ordenou := false; (* Pelos menos um elemento esta desordenado *)
                   auxiliaNome := arDeNomesEMats[i].nome;
                   auxiliaMatricula := arDeNomesEMats[i].matricula;
                   arDeNomesEMats[i].nome := arDeNomesEMats[i + 1].nome;
                   arDeNomesEMats[i].matricula := arDeNomesEMats[i + 1].matricula;
                   arDeNomesEMats[i + 1].nome := auxiliaNome;
                   arDeNomesEMats[i + 1].matricula := auxiliaMatricula;
               end;
           end;
       end;
end; (* OrdenaNomes *)

begin
   assign(arquivoDeEmpregados1, 'a:\matENome.txt');
   assign(arquivoDeEmpregados2, 'a:\matESala.txt');

   reset(arquivoDeEmpregados1);
   reset(arquivoDeEmpregados2);

   (* Leitura das matriculas e nomes dos funcionarios *)
   while not EOF(arquivoDeEmpregados1) do
       for i := 1 to EMPREGADOS do
           with nomeEMatricula[i] do begin
               readln(arquivoDeEmpregados1, matricula);
               readln(arquivoDeEmpregados1, nome);
           end;

   (* Leitura das matriculas e salarios dos funcionarios *)
   while not EOF(arquivoDeEmpregados2) do
       for i := 1 to EMPREGADOS do
           with salarioEMatricula[i] do begin
               readln(arquivoDeEmpregados2, matricula);
               readln(arquivoDeEmpregados2, salario)
           end;

   OrdenaNomes(nomeEmatricula);

   k := 1;
   (* Armazenamento dos nomes dos funcionarios com os rspectivos salarios *)
   (* em um arranjo auxiliar                                              *)
   for i := 1 to EMPREGADOS do
       for j := 1 to EMPREGADOS do
           if (nomeEMatricula[i].matricula = salarioEMatricula[j].matricula) then begin
               nomeESalario[k].nome := nomeEMatricula[i].nome;
               nomeESalario[k].salario := salarioEMatricula[j].salario;
           k := k + 1;
           end;

   (* Impressao do nome do funcionario e do seu salario *)
   for k := 1 to EMPREGADOS do begin
       write(nomeESalario[k].nome);
       writeln('  $',nomeESalario[k].salario:6:2);
   end;

   (* Fechamento dos arquivos que foram abertos para a leitura *)
   close(arquivoDeEmpregados1);
   close(arquivoDeEmpregados2);
end.
